<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits Struct Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html">sds</a></li><li class="navelem"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html">InProcessSDSTraits</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Structure for specifying the traits of a <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a> which works between threads in a single process.  
 <a href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_in_process_s_d_s_8h_source.html">InProcessSDS.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a663a9c9081834aec8c50515b785ac96d"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#a663a9c9081834aec8c50515b785ac96d">AtomicIndex</a> = std::atomic&lt; uint64_t &gt;</td></tr>
<tr class="memdesc:a663a9c9081834aec8c50515b785ac96d"><td class="mdescLeft">&#160;</td><td class="mdescRight">C++11 std::atomic is sufficient for in-process atomic variables.  <a href="#a663a9c9081834aec8c50515b785ac96d">More...</a><br /></td></tr>
<tr class="separator:a663a9c9081834aec8c50515b785ac96d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90da973f103d94779e1bec5c480d9bc1"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#a90da973f103d94779e1bec5c480d9bc1">AtomicBool</a> = std::atomic&lt; bool &gt;</td></tr>
<tr class="memdesc:a90da973f103d94779e1bec5c480d9bc1"><td class="mdescLeft">&#160;</td><td class="mdescRight">C++11 std::atomic is sufficient for in-process atomic variables.  <a href="#a90da973f103d94779e1bec5c480d9bc1">More...</a><br /></td></tr>
<tr class="separator:a90da973f103d94779e1bec5c480d9bc1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7ff4eb1e4f1628fb39ba7534b2bdb32"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#af7ff4eb1e4f1628fb39ba7534b2bdb32">Buffer</a> = std::vector&lt; uint8_t &gt;</td></tr>
<tr class="memdesc:af7ff4eb1e4f1628fb39ba7534b2bdb32"><td class="mdescLeft">&#160;</td><td class="mdescRight">A std::vector provides a simple container to hold a buffer for in-process usage.  <a href="#af7ff4eb1e4f1628fb39ba7534b2bdb32">More...</a><br /></td></tr>
<tr class="separator:af7ff4eb1e4f1628fb39ba7534b2bdb32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06611059ea190b04a373c72b967e0893"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#a06611059ea190b04a373c72b967e0893">Mutex</a> = std::mutex</td></tr>
<tr class="memdesc:a06611059ea190b04a373c72b967e0893"><td class="mdescLeft">&#160;</td><td class="mdescRight">A std::mutex provides a lock which will work for in-process usage.  <a href="#a06611059ea190b04a373c72b967e0893">More...</a><br /></td></tr>
<tr class="separator:a06611059ea190b04a373c72b967e0893"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a48c12727bb218e2e3540fa1e426b2949"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#a48c12727bb218e2e3540fa1e426b2949">ConditionVariable</a> = std::condition_variable</td></tr>
<tr class="memdesc:a48c12727bb218e2e3540fa1e426b2949"><td class="mdescLeft">&#160;</td><td class="mdescRight">A std::condition_variable provides a condition variable which will work for in-process usage.  <a href="#a48c12727bb218e2e3540fa1e426b2949">More...</a><br /></td></tr>
<tr class="separator:a48c12727bb218e2e3540fa1e426b2949"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:ac80d3b63c09d3d8d438977850e45ce9b"><td class="memItemLeft" align="right" valign="top">static constexpr const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#ac80d3b63c09d3d8d438977850e45ce9b">traitsName</a> = &quot;alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits&quot;</td></tr>
<tr class="memdesc:ac80d3b63c09d3d8d438977850e45ce9b"><td class="mdescLeft">&#160;</td><td class="mdescRight">A unique identifier representing this combination of traits.  <a href="#ac80d3b63c09d3d8d438977850e45ce9b">More...</a><br /></td></tr>
<tr class="separator:ac80d3b63c09d3d8d438977850e45ce9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Structure for specifying the traits of a <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a> which works between threads in a single process. </p>
</div><h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a90da973f103d94779e1bec5c480d9bc1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a90da973f103d94779e1bec5c480d9bc1">&#9670;&nbsp;</a></span>AtomicBool</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#a90da973f103d94779e1bec5c480d9bc1">alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits::AtomicBool</a> =  std::atomic&lt;bool&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>C++11 std::atomic is sufficient for in-process atomic variables. </p>

</div>
</div>
<a id="a663a9c9081834aec8c50515b785ac96d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a663a9c9081834aec8c50515b785ac96d">&#9670;&nbsp;</a></span>AtomicIndex</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#a663a9c9081834aec8c50515b785ac96d">alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits::AtomicIndex</a> =  std::atomic&lt;uint64_t&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>C++11 std::atomic is sufficient for in-process atomic variables. </p>

</div>
</div>
<a id="af7ff4eb1e4f1628fb39ba7534b2bdb32"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af7ff4eb1e4f1628fb39ba7534b2bdb32">&#9670;&nbsp;</a></span>Buffer</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#af7ff4eb1e4f1628fb39ba7534b2bdb32">alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits::Buffer</a> =  std::vector&lt;uint8_t&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A std::vector provides a simple container to hold a buffer for in-process usage. </p>

</div>
</div>
<a id="a48c12727bb218e2e3540fa1e426b2949"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a48c12727bb218e2e3540fa1e426b2949">&#9670;&nbsp;</a></span>ConditionVariable</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#a48c12727bb218e2e3540fa1e426b2949">alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits::ConditionVariable</a> =  std::condition_variable</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A std::condition_variable provides a condition variable which will work for in-process usage. </p>

</div>
</div>
<a id="a06611059ea190b04a373c72b967e0893"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a06611059ea190b04a373c72b967e0893">&#9670;&nbsp;</a></span>Mutex</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#a06611059ea190b04a373c72b967e0893">alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits::Mutex</a> =  std::mutex</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A std::mutex provides a lock which will work for in-process usage. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="ac80d3b63c09d3d8d438977850e45ce9b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac80d3b63c09d3d8d438977850e45ce9b">&#9670;&nbsp;</a></span>traitsName</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr const char* alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits::traitsName = &quot;alexaClientSDK::avsCommon::utils::sds::InProcessSDSTraits&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A unique identifier representing this combination of traits. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/include/AVSCommon/Utils/SDS/<a class="el" href="_in_process_s_d_s_8h_source.html">InProcessSDS.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
